<template>
  <div class="amountInput flex flex-middle">
    <Btn
      v-if="!disableSteps"
      class="amountInput-left"
      @touchstart="touchstart(-step)"
      @touchend="touchend(-step)"
      @click="changeAmount(-step)"><i class="i-icon-minus"></i></Btn>
    <div
      class="amountInput-body"
      v-if="disabledInput">
      <span>{{syncedValue}}</span><span><span
      class="text-09"
      style="margin-left: 2px;">{{label}}</span></span>
    </div>
    <label
      class="amountInput-body"
      v-else>
      <input
        pattern="\d+(,\d{2})?"
        type="number"
        min="step"
        v-model.lazy="syncedValue"
        class="text-bold amountInput-value"><span class="text-09">{{label}}</span></label>
    <Btn
      v-if="!disableSteps"
      class="amountInput-right"
      @touchstart="touchstart(step)"
      @touchend="touchend(step)"
      @click="changeAmount(step)"><i class="i-icon-plus"></i></Btn>
  </div>
</template>

<script>
  import Btn from '~/components/UI/Btn';

  export default {
    name: "AmountInput",
    props: {
      label: {
        type: String,
        default: 'EOS'
      },
      disabledInput: {
        type: Boolean,
        default: true
      },
      disableSteps: {
        type: Boolean,
        default: false
      },
      value: {
        type: Number,
        default: 0
      },
      step: {
        type: Number,
        default: 1
      }
    },
    data() {
      return {
        interval: null
      }
    },
    components: {
      Btn
    },
    computed: {
      syncedValue: {
        set(val) {
          this.$emit('input', parseFloat(val));
        },
        get() {
          return this.value;
        }
      }
    },
    methods: {
      changeAmount(val) {
        if (val > 0) {
          this.ga('plus');
        } else if (val < 0) {
          this.ga('minus');
        }
        this.$emit('change', val);
      },
      touchstart(val) {
        this.interval = setInterval(_ => {
          clearInterval(this.interval);
          this.interval = setInterval(_ => {
            this.changeAmount(val);
          }, 100);
        }, 600);
      },
      touchend() {
        clearInterval(this.interval);
      }
    }
  }
</script>
